Index: /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 8878)
+++ /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 8879)
@@ -35,6 +35,6 @@
    USE in_out_manager   ! I/O manager
    USE lib_mpp          ! MPP library
-#if defined key_lim2
-   USE ice_2            ! LIM2
+#if defined key_lim3
+   USE ice,   ONLY: hm_i, at_i, at_i_b
 #endif
    USE sbc_oce          ! Surface boundary condition variables.
@@ -809,5 +809,5 @@
       INTEGER  ::   it
       REAL(wp) ::   zincwgt   ! IAU weight for current time step
-#if defined key_lim2
+#if defined key_lim3
       REAL(wp), DIMENSION(jpi,jpj) ::   zofrld, zohicif, zseaicendg, zhicifinc  ! LIM
       REAL(wp) ::   zhicifmin = 0.5_wp      ! ice minimum depth in metres
@@ -831,20 +831,19 @@
             ENDIF
             !
-            ! Sea-ice : LIM-3 case (to add)
-            !
-#if defined key_lim2
-            ! Sea-ice : LIM-2 case
-            zofrld (:,:) = frld(:,:)
-            zohicif(:,:) = hicif(:,:)
-            !
-            frld  = MIN( MAX( frld (:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-            pfrld = MIN( MAX( pfrld(:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-            fr_i(:,:) = 1.0_wp - frld(:,:)        ! adjust ice fraction
-            !
-            zseaicendg(:,:) = zofrld(:,:) - frld(:,:)   ! find out actual sea ice nudge applied
+            ! Sea-ice : LIM-3 case
+            !
+#if defined key_lim3
+            zofrld (:,:) = 1._wp - at_i(:,:)
+            zohicif(:,:) = hm_i(:,:)
+            !
+            at_i  (:,:) = 1. - MIN( MAX( 1.-at_i  (:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
+            at_i_b(:,:) = 1. - MIN( MAX( 1.-at_i_b(:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
+            fr_i(:,:) = at_i(:,:)        ! adjust ice fraction
+            !
+            zseaicendg(:,:) = zofrld(:,:) - (1. - at_i(:,:))   ! find out actual sea ice nudge applied
             !
             ! Nudge sea ice depth to bring it up to a required minimum depth
-            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-               zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
+            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hm_i(:,:) < zhicifmin ) 
+               zhicifinc(:,:) = (zhicifmin - hm_i(:,:)) * zincwgt    
             ELSEWHERE
                zhicifinc(:,:) = 0.0_wp
@@ -852,6 +851,5 @@
             !
             ! nudge ice depth
-            hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-            phicif(:,:) = phicif(:,:) + zhicifinc(:,:)       
+            hm_i (:,:) = hm_i (:,:) + zhicifinc(:,:)
             !
             ! seaice salinity balancing (to add)
@@ -882,27 +880,26 @@
             neuler = 0                    ! Force Euler forward step
             !
-            ! Sea-ice : LIM-3 case (to add)
-            !
-#if defined key_lim2
-            ! Sea-ice : LIM-2 case.
-            zofrld(:,:)=frld(:,:)
-            zohicif(:,:)=hicif(:,:)
+            ! Sea-ice : LIM-3 case
+            !
+#if defined key_lim3
+            zofrld (:,:) = 1._wp - at_i(:,:)
+            zohicif(:,:) = hm_i(:,:)
             ! 
             ! Initialize the now fields the background + increment
-            frld (:,:) = MIN( MAX( frld(:,:) - seaice_bkginc(:,:), 0.0_wp), 1.0_wp)
-            pfrld(:,:) = frld(:,:) 
-            fr_i (:,:) = 1.0_wp - frld(:,:)                ! adjust ice fraction
-            zseaicendg(:,:) = zofrld(:,:) - frld(:,:)      ! find out actual sea ice nudge applied
+            at_i(:,:) = 1. - MIN( MAX( 1.-at_i(:,:) - seaice_bkginc(:,:), 0.0_wp), 1.0_wp)
+            at_i_b(:,:) = at_i(:,:) 
+            fr_i(:,:) = at_i(:,:)        ! adjust ice fraction
+            !
+            zseaicendg(:,:) = zofrld(:,:) - (1. - at_i(:,:))   ! find out actual sea ice nudge applied
             !
             ! Nudge sea ice depth to bring it up to a required minimum depth
-            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-               zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
+            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hm_i(:,:) < zhicifmin ) 
+               zhicifinc(:,:) = (zhicifmin - hm_i(:,:)) * zincwgt    
             ELSEWHERE
-               zhicifinc(:,:) = 0._wp
+               zhicifinc(:,:) = 0.0_wp
             END WHERE
             !
             ! nudge ice depth
-            hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-            phicif(:,:) = phicif(:,:)       
+            hm_i (:,:) = hm_i (:,:) + zhicifinc(:,:)
             !
             ! seaice salinity balancing (to add)
@@ -926,5 +923,5 @@
          ENDIF
 
-!#if defined defined key_lim2 || defined key_cice
+!#if defined defined key_lim3 || defined key_cice
 !
 !            IF (ln_seaicebal ) THEN       
Index: /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 8878)
+++ /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 8879)
@@ -55,18 +55,11 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::  tem
       REAL(wp), POINTER, DIMENSION(:,:) ::  sal
-#if defined key_lim2
-      LOGICAL                           ::   ll_frld
-      LOGICAL                           ::   ll_hicif
-      LOGICAL                           ::   ll_hsnif
-      REAL(wp), POINTER, DIMENSION(:)   ::   frld
-      REAL(wp), POINTER, DIMENSION(:)   ::   hicif
-      REAL(wp), POINTER, DIMENSION(:)   ::   hsnif
-#elif defined key_lim3
+#if defined key_lim3
       LOGICAL                           ::   ll_a_i
-      LOGICAL                           ::   ll_ht_i
-      LOGICAL                           ::   ll_ht_s
+      LOGICAL                           ::   ll_h_i
+      LOGICAL                           ::   ll_h_s
       REAL(wp), POINTER, DIMENSION(:,:) ::   a_i    !: now ice leads fraction climatology
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ht_i   !: Now ice  thickness climatology
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ht_s   !: now snow thickness
+      REAL(wp), POINTER, DIMENSION(:,:) ::   h_i    !: Now ice  thickness climatology
+      REAL(wp), POINTER, DIMENSION(:,:) ::   h_s    !: now snow thickness
 #endif
 #if defined key_top
Index: /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 8878)
+++ /branches/UKMO/dev_r8126_LIM3_couple/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 8879)
@@ -25,9 +25,7 @@
    USE iom             ! IOM library
    USE in_out_manager  ! I/O logical units
-#if defined key_lim2
-   USE ice_2
-#elif defined key_lim3
+#if defined key_lim3
    USE ice
-   USE limvar          ! redistribute ice input into categories
+   USE icevar          ! redistribute ice input into categories
 #endif
    USE sbcapr
@@ -50,5 +48,5 @@
 
 #if defined key_lim3
-   LOGICAL :: ll_bdylim3                  ! determine whether ice input is lim2 (F) or lim3 (T) type
+   LOGICAL :: ll_bdylim3                  ! determine whether ice input is 1cat (F) or Xcat (T) type
    INTEGER :: jfld_hti, jfld_hts, jfld_ai ! indices of ice thickness, snow thickness and concentration in bf structure
 #endif
@@ -176,33 +174,5 @@
             ENDIF
 
-#if defined key_lim2
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN 
-               ilen1(:) = nblen(:)
-               IF( dta%ll_frld ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%frld(ib) = frld(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-               IF( dta%ll_hicif ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%hicif(ib) = hicif(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-               IF( dta%ll_hsnif ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%hsnif(ib) = hsnif(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-            ENDIF
-#elif defined key_lim3
+#if defined key_lim3
             IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
@@ -217,5 +187,5 @@
                   END DO
                ENDIF
-               IF( dta%ll_ht_i ) THEN
+               IF( dta%ll_h_i ) THEN
                   igrd = 1   
                   DO jl = 1, jpl
@@ -223,9 +193,9 @@
                         ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                         ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%ht_i (ib,jl) =  ht_i(ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(ib_bdy)%h_i (ib,jl) =  h_i(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
                ENDIF
-               IF( dta%ll_ht_s ) THEN
+               IF( dta%ll_h_s ) THEN
                   igrd = 1   
                   DO jl = 1, jpl
@@ -233,5 +203,5 @@
                         ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                         ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%ht_s (ib,jl) =  ht_s(ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(ib_bdy)%h_s (ib,jl) =  h_s(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
@@ -373,7 +343,7 @@
                ENDIF
 #if defined key_lim3
-               IF( .NOT. ll_bdylim3 .AND. cn_ice_lim(ib_bdy) /= 'none' .AND. nn_ice_lim_dta(ib_bdy) == 1 ) THEN ! bdy ice input (case input is lim2 type)
-     	          CALL lim_var_itd ( bf(jfld_hti)%fnow(:,1,1), bf(jfld_hts)%fnow(:,1,1), bf(jfld_ai)%fnow(:,1,1), &
-                                  & dta_bdy(ib_bdy)%ht_i,     dta_bdy(ib_bdy)%ht_s,     dta_bdy(ib_bdy)%a_i     )
+               IF( .NOT. ll_bdylim3 .AND. cn_ice_lim(ib_bdy) /= 'none' .AND. nn_ice_lim_dta(ib_bdy) == 1 ) THEN ! bdy ice input (case input is 1cat)
+     	          CALL ice_var_itd ( bf(jfld_hti)%fnow(:,1,1), bf(jfld_hts)%fnow(:,1,1), bf(jfld_ai)%fnow(:,1,1), &
+                                  & dta_bdy(ib_bdy)%h_i,     dta_bdy(ib_bdy)%h_s,     dta_bdy(ib_bdy)%a_i     )
                ENDIF
 #endif
@@ -449,14 +419,10 @@
       TYPE(FLD_N) ::   bn_tem, bn_sal, bn_u3d, bn_v3d   ! 
       TYPE(FLD_N) ::   bn_ssh, bn_u2d, bn_v2d           ! informations about the fields to be read
-#if defined key_lim2
-      TYPE(FLD_N) ::   bn_frld, bn_hicif, bn_hsnif      !
-#elif defined key_lim3
-      TYPE(FLD_N) ::   bn_a_i, bn_ht_i, bn_ht_s      
+#if defined key_lim3
+      TYPE(FLD_N) ::   bn_a_i, bn_h_i, bn_h_s      
 #endif
       NAMELIST/nambdy_dta/ cn_dir, bn_tem, bn_sal, bn_u3d, bn_v3d, bn_ssh, bn_u2d, bn_v2d 
-#if defined key_lim2
-      NAMELIST/nambdy_dta/ bn_frld, bn_hicif, bn_hsnif
-#elif defined key_lim3
-      NAMELIST/nambdy_dta/ bn_a_i, bn_ht_i, bn_ht_s
+#if defined key_lim3
+      NAMELIST/nambdy_dta/ bn_a_i, bn_h_i, bn_h_s
 #endif
       NAMELIST/nambdy_dta/ ln_full_vel, nb_jpk_bdy
@@ -475,5 +441,5 @@
                                ,nn_dyn3d_dta(ib_bdy)       &
                                ,nn_tra_dta(ib_bdy)         &
-#if ( defined key_lim2 || defined key_lim3 )
+#if defined key_lim3
                               ,nn_ice_lim_dta(ib_bdy)    &
 #endif
@@ -496,5 +462,5 @@
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
          ENDIF
-#if ( defined key_lim2 || defined key_lim3 )
+#if defined key_lim3
          IF( cn_ice_lim(ib_bdy) /= 'none' .and. nn_ice_lim_dta(ib_bdy) == 1  ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
@@ -637,40 +603,8 @@
             ENDIF
 
-#if defined key_lim2
+#if defined key_lim3
             ! sea ice
             IF( nn_ice_lim_dta(ib_bdy) == 1 ) THEN
-
-               IF( dta%ll_frld ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_frld
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-               IF( dta%ll_hicif ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_hicif
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-               IF( dta%ll_hsnif ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_hsnif
-                  ibdy(jfld) = ib_bdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-               ENDIF
-
-            ENDIF
-#elif defined key_lim3
-            ! sea ice
-            IF( nn_ice_lim_dta(ib_bdy) == 1 ) THEN
-               ! Test for types of ice input (lim2 or lim3) 
+               ! Test for types of ice input (1cat or Xcat) 
                ! Build file name to find dimensions 
                clname=TRIM( cn_dir )//TRIM(bn_a_i%clname)
@@ -689,7 +623,7 @@
 
       	       IF ( zndims == 4 ) THEN
-                 ll_bdylim3 = .TRUE.   ! lim3 input
+                 ll_bdylim3 = .TRUE.   ! Xcat input
                ELSE
-                 ll_bdylim3 = .FALSE.  ! lim2 input      
+                 ll_bdylim3 = .FALSE.  ! 1cat input      
                ENDIF
                ! End test
@@ -704,7 +638,7 @@
                ENDIF
 
-               IF( dta%ll_ht_i ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_ht_i
+               IF( dta%ll_h_i ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_h_i
                   ibdy(jfld) = ib_bdy
                   igrid(jfld) = 1
@@ -713,7 +647,7 @@
                ENDIF
 
-               IF( dta%ll_ht_s ) THEN
-                  jfld = jfld + 1
-                   blf_i(jfld) = bn_ht_s
+               IF( dta%ll_h_s ) THEN
+                  jfld = jfld + 1
+                   blf_i(jfld) = bn_h_s
                   ibdy(jfld) = ib_bdy
                   igrid(jfld) = 1
@@ -848,44 +782,29 @@
          ENDIF
 
-#if defined key_lim2
+#if defined key_lim3
          IF (cn_ice_lim(ib_bdy) /= 'none') THEN
             IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN
-               ALLOCATE( dta_bdy(ib_bdy)%frld(nblen(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hicif(nblen(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hsnif(nblen(1)) )
+               ALLOCATE( dta_bdy(ib_bdy)%a_i(nblen(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%h_i(nblen(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%h_s(nblen(1),jpl) )
             ELSE
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%frld  => bf(jfld)%fnow(:,1,1)
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%hicif => bf(jfld)%fnow(:,1,1)
-               jfld = jfld + 1
-               dta_bdy(ib_bdy)%hsnif => bf(jfld)%fnow(:,1,1)
-            ENDIF
-         ENDIF
-#elif defined key_lim3
-         IF (cn_ice_lim(ib_bdy) /= 'none') THEN
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN
-               ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
-               ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
-               ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
-            ELSE
-               IF ( ll_bdylim3 ) THEN ! case input is lim3 type
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%a_i  => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ht_i => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ht_s => bf(jfld)%fnow(:,1,:)
-               ELSE ! case input is lim2 type
+               IF ( ll_bdylim3 ) THEN ! case input is Xcat
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%a_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%h_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%h_s => bf(jfld)%fnow(:,1,:)
+               ELSE ! case input is 1cat
                   jfld_ai  = jfld + 1
                   jfld_hti = jfld + 2
                   jfld_hts = jfld + 3
                   jfld     = jfld + 3
-                  ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
-                  dta_bdy(ib_bdy)%a_i (:,:) = 0._wp
-                  dta_bdy(ib_bdy)%ht_i(:,:) = 0._wp
-                  dta_bdy(ib_bdy)%ht_s(:,:) = 0._wp
+                  ALLOCATE( dta_bdy(ib_bdy)%a_i(nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(ib_bdy)%h_i(nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(ib_bdy)%h_s(nblen(1),jpl) )
+                  dta_bdy(ib_bdy)%a_i(:,:) = 0._wp
+                  dta_bdy(ib_bdy)%h_i(:,:) = 0._wp
+                  dta_bdy(ib_bdy)%h_s(:,:) = 0._wp
                ENDIF
 
